//
// Numerical data type used to count the number of floating point operations performed in the course of some computation.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


here = getcwd();
chdir("../Tools");
exec("Tools.sce");
chdir(here);
clear here;

getf("UnitTests.sci");
exec("Type.sce");
getf("Ops.sci");

global FLOPCOUNT_UNIT_TESTS;
if (FLOPCOUNT_UNIT_TESTS)
	chdir("tests");
	t = timer();

	printf("FlOpCounter unit tests\n");
	FLOPCTR_Reset();
	exec("Test_FlOpCounter_AddsMults.sce");
	exec("Test_FlOpCounter_SubsDivs.sce");
	exec("Test_FlOpCounter_Manip.sce");
	exec("Test_FlOpCounter_Transposition.sce");
	exec("Test_FlOpCounter_Comparison.sce");
	exec("Test_FlOpCounter_ExpsMons.sce");
	exec("Test_FlOpCounter_ElemwisePrims.sce");

	t = timer();
	FLOPCTR_Reset();
	chdir("..");
	printf("FlOpCount unit tests all successful!  Duration : %.1f s\n", t);
	clear t;
end;  // if

printf("FlOpCount library loaded successfully.\n");


// End of module.
