//
// Tests on comparison operators.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


// Equality comparison.
assertBoolFlOpCount(flopctr(5) == flopctr(5), %t, [1,0,0,2,1,0]);
assertBoolFlOpCount(flopctr([3,7,0]) == [1,7,-2], [%f,%t,%f], [3,0,0,6,3,0]);
assertBoolFlOpCount([1;0;2;8] == flopctr([2;0;-2;0]), [%f;%t;%f;%f], [4,0,0,8,4,0]);
assertBoolFlOpCount(flopctr([1,2,3 ; 4,5,6 ; 7,8,9]) == [1,3,2 ; 6,5,4 ; 8,7,9], [%t,%f,%f ; %f,%t,%f ; %f,%f,%t], ...
		[9,0,0,18,9,0]);
assertBoolFlOpCount([] == flopctr(3), %f, [0,0,0,0,0,0]);
assertBoolFlOpCount(flopctr([3,5,6]) == flopctr([3,5]), %f, [0,0,0,0,0,0]);
assertBoolFlOpCount(flopctr([3,4,2 ; 2,3,0]) == [1,2 ; 2,3], %f, [0,0,0,0,0,0]);
assertBoolFlOpCount(flopctr([]) == [], %t, [0,0,0,0,0,0]);


// Difference comparison.
assertBoolFlOpCount(flopctr(5) <> flopctr(5), %f, [1,0,0,2,1,0]);
assertBoolFlOpCount(flopctr([3,7,0]) <> [1,7,-2], [%t,%f,%t], [3,0,0,6,3,0]);
assertBoolFlOpCount([1;0;2;8] <> flopctr([2;0;-2;0]), [%t;%f;%t;%t], [4,0,0,8,4,0]);
assertBoolFlOpCount(flopctr([1,2,3 ; 4,5,6 ; 7,8,9]) <> [1,3,2 ; 6,5,4 ; 8,7,9], [%f,%t,%t ; %t,%f,%t ; %t,%t,%f], ...
		[9,0,0,18,9,0]);
assertBoolFlOpCount([] <> flopctr(3), %t, [0,0,0,0,0,0]);
assertBoolFlOpCount(flopctr([3,5,6]) <> flopctr([3,5]), %t, [0,0,0,0,0,0]);
assertBoolFlOpCount(flopctr([3,4,2 ; 2,3,0]) <> [1,2 ; 2,3], %t, [0,0,0,0,0,0]);
assertBoolFlOpCount(flopctr([]) <> [], %f, [0,0,0,0,0,0]);


// Strict order comparison.
assertBoolFlOpCount(flopctr(2) < flopctr(2), %f, [1,0,0,2,1,0]);
assertBoolFlOpCount(flopctr([1;3;5;8]) < [3;2;3;10], [%t;%f;%f;%t], [4,0,0,8,4,0]);
assertBoolFlOpCount([4,0,1,9,-3] < flopctr([3,0,1,10,0]), [%f,%f,%f,%t,%t], [5,0,0,10,5,0]);
assertBoolFlOpCount(flopctr([8,-2 ; 0,4 ; -1,3]) < [9,-2 ; -3,6 ; -4,5], [%t,%f ; %f,%t ; %f,%t], [6,0,0,12,6,0]);

// Strict inverse order comparison.
assertBoolFlOpCount(flopctr(2) > flopctr(2), %f, [1,0,0,2,1,0]);
assertBoolFlOpCount(flopctr([1;3;5;8]) > [3;2;3;10], [%f;%t;%t;%f], [4,0,0,8,4,0]);
assertBoolFlOpCount([4,0,1,9,-3] > flopctr([3,0,1,10,0]), [%t,%f,%f,%f,%f], [5,0,0,10,5,0]);
assertBoolFlOpCount(flopctr([8,-2 ; 0,4 ; -1,3]) > [9,-2 ; -3,6 ; -4,5], [%f,%f ; %t,%f ; %t,%f], [6,0,0,12,6,0]);

// Order comparison.
assertBoolFlOpCount(flopctr(2) <= flopctr(2), %t, [1,0,0,2,1,0]);
assertBoolFlOpCount(flopctr([1;3;5;8]) <= [3;2;3;10], [%t;%f;%f;%t], [4,0,0,8,4,0]);
assertBoolFlOpCount([4,0,1,9,-3] <= flopctr([3,0,1,10,0]), [%f,%t,%t,%t,%t], [5,0,0,10,5,0]);
assertBoolFlOpCount(flopctr([8,-2 ; 0,4 ; -1,3]) <= [9,-2 ; -3,6 ; -4,5], [%t,%t ; %f,%t ; %f,%t], [6,0,0,12,6,0]);

// Inverse order comparison.
assertBoolFlOpCount(flopctr(2) >= flopctr(2), %t, [1,0,0,2,1,0]);
assertBoolFlOpCount(flopctr([1;3;5;8]) >= [3;2;3;10], [%f;%t;%t;%f], [4,0,0,8,4,0]);
assertBoolFlOpCount([4,0,1,9,-3] >= flopctr([3,0,1,10,0]), [%t,%t,%t,%f,%f], [5,0,0,10,5,0]);
assertBoolFlOpCount(flopctr([8,-2 ; 0,4 ; -1,3]) >= [9,-2 ; -3,6 ; -4,5], [%f,%t ; %t,%f ; %t,%f], [6,0,0,12,6,0]);


printf("    Comparison : all unit tests passed.\n");


// End of script.
