//
// Tests on subtractions and various inversions and divisions of FlOpCounters.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


// Subtractions.
assertFlOpCount(5 - flopctr(9), -4, %eps, [1,0,0,2,1,0]);
assertFlOpCount(flopctr([3,0,2]) - [-1,4,0], [4,-4,2], %eps, [3,0,0,6,3,0]);
assertFlOpCount([1;6;-9;0] - flopctr(5), [-4;1;-14;-5], %eps, [4,8,0,24,12,0]);
assertFlOpCount(flopctr([1,4,0 ; 9,-8,3]) - 10, [-9,-6,-10 ; -1,-18,-7], %eps, [6,8,0,28,14,0]);

// Element-wise right divisions.
assertFlOpCount(flopctr(4) ./ 8, 0.5, %eps, [0,1,1,3,2,0]);
assertFlOpCount(flopctr([4;8;16]) ./ 2, [2;4;8], %eps, [0,9,3,21,12,0]);
assertFlOpCount(flopctr(16) ./ [2,4,8], [8,4,2], %eps, [0,7,3,17,10,0]);
assertFlOpCount([1,5 ; 0,-6] ./ flopctr([2,-9 ; 2,4]), [0.5,-5/9 ; 0,-1.5], %eps, [0,4,4,12,8,0]);

// Element-wise left divisions.
// TODO!

// Right divisions.
assertFlOpCount(flopctr(4) / 8, 0.5, %eps, [0,1,1,3,2,0]);
assertFlOpCount(flopctr([4;8;16]) / 2, [2;4;8], %eps, [0,3,1,7,4,0]);
assertFlOpCount(flopctr(16) / [2,4,8], [8,4,2], %eps, [0,7,3,17,10,0]);
assertFlOpCount([5,0 ; -10,20] / flopctr(-5), [-1,0 ; 2,-4], %eps, [0,10,1,21,11,0]);

// Left divisions.
// TODO!

printf("    Subs and divs : all unit tests passed.\n");


// End of script.
