//
// Functions : setup and tools for unit testing.
//
// Author : Benoit Hamelin
// 2002 Universite de Sherbrooke
//


function []=assert(cnd)
	if (~cnd) then
		error("Assertion failed.");
	end  // if
endfunction


function []=assertError(action)
	errorcode = execstr(action, 'errcatch', 'n')
	errclear()
	if (errorcode == 0)
		error("Error assertion failed (action succeeded without error).");
	end  // if
endfunction


function []=assertSize(object, s)
	assert(and(size(object) == s));
endfunction


// End of module.

