//
// Backward visitor that computes derivative of some R^m->R^n function in
// given directions, using automatic differentiation chain rule.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


// Fields of a derivator visitor :
//
// * The dimension of the independant variable.
// * List of adjoints calculated at each node.
// * List of independant variable nodes (for final derivative cumulation).
// * Flag telling whether the solely numerical values or Sciad representation
//   of the derivative must be calculated.
//
global SCIAD_DERIVATOR_FIELDS;
SCIAD_DERIVATOR_FIELDS = [SCIAD_VISITOR_FIELDS, "n", "adjointList", ...
		"ivarNodes", "numericalOnly"];

// Global variables for reconstruction of the graph the derivative of some
// expression.
global SCIAD_RGD_ADJ_LIST SCIAD_RGD_ORIG_EXPR SCIAD_RGD_LIST_PREDEC;
global SCIAD_RGD_DICT_NODE SCIAD_RGD_DICT_ADJ;
global SCIAD_RGD_DERIV;
SCIAD_RGD_ADJ_LIST = list();
SCIAD_RGD_ORIG_EXPR = list();
SCIAD_RGD_DICT_NODE = [];
SCIAD_RGD_DICT_ADJ = [];
SCIAD_RGD_DERIV = list();


getf("Derivator.sci");


// End of module.

