//
// Definitions for analytical expressions (which can be derivated).
//
// Author : Benoit Hamelin
// 2002 Universit de Sherbrooke
//


// ADEXPR - Analytical expression of some function represented with expression graphs.
//
// dims - The size of the matrix that results of evaluation of this expression.
// nodes - List of node objects of the graph that describes the function (and its eventual derivatives).
// edges - 2xN matrix, where each column is a [head;tail] 2-vector that describes an edge using node indices.
// root - Root node of the directed acyclic graph.
//
global SCIAD_EXPR_FIELDS;
SCIAD_EXPR_FIELDS = ["ADEXPR", "dims", "nodes", "edges", "root"];


getf("Expr.sci");
getf("ExprOps.sci");
getf("ExprTrigo.sci");


// End of module.

