//
// Forward visitor that computes right finite difference for some function built as an expression, using finite difference chain
// rule.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


// Fields of an finite difference calculation visitor :
//
// * Original right increment.
// * Numerical zero for required precision.
// * List of finite differences calculated at each node.
// * Number of nodes that need to compile a convergent series.
// * Number of convergent series terms computed.
//
global SCIAD_FDCALC_FIELDS;
SCIAD_FDCALC_FIELDS = [SCIAD_VISITOR_FIELDS, "increment", "numzero", "fdList", "nbNodesSeries", "nbTermsSeries"];


getf("FiniteDiffCalc.sci");


// End of module.

