// Visitor.sci
//
// Author : Benoit Hamelin
// 2002 Universite de Sherbrooke
//
// Base tools for visitor implementation.
//


// SCIAD expression visitor.
//
// We have a field for every visitor method that must be implemented.
// listPredec - List indexed by node indices that contain a vector of the
//     indexes of its predecessors (output of Expr_ListPredecessors for
//     expression being visited).
//
global SCIAD_VISITOR_FIELDS;
SCIAD_VISITOR_FIELDS = ["VISITOR",...
	"listPredec",...
	"VisitIVar",...
	"VisitConst",...
	"VisitAdd",...
	"VisitAddInv",...
	"VisitT",...
	"VisitMult",...
	"VisitElemMult",...
	"VisitInv",...
	"VisitElemInv",...
	"VisitExp",...
	"VisitElemExp",...
	"VisitLog",...
	"VisitMonome",...
	"VisitElemMonome",...
	"VisitSin",...
	"VisitCos",...
	"VisitAtan",...
	"VisitAbs",...
	"VisitStub" ...
	];

global SCIAD_VISITOR SCIAD_EXPR;
SCIAD_VISITOR = list();
SCIAD_EXPR = list();


//getf("Visitor.sci");


// End of module.

