//
// Tests on derivation of expressions to expressions -- absolute value.
//
// Author : Benoit Hamelin
// 2004 Universit de Sherbrooke
//


// TODO -- This testing is not exhaustive, but should suffice, being the non-derivativity of the absolute value.

x = ad_ivar([7;-1;1;-2;3]);
F = abs([-x(1)*x(3) ; x(2)*x(4) ; x(3) + 3*x(4) ; x(5) - x(1)]);
DF = Expr_Jacobian(F, 5, eye(4,4), %f);
assertExpr(DF, ...
	[ ...
		 1,  0,  7,  0,  0 ; ...
		 0, -2,  0, -1,  0 ; ...
		 0,  0, -1, -3,  0 ; ...
		 1,  0,  0,  0, -1   ...
	]);


clear x;
clear F;
clear DF;

printf("Deriv. expr. - Absolute value : all unit tests passed.\n");


// End of script.

