//
// Tests on derivation of expressions to expressions -- circular trigonometrics.
//
// Author : Benoit Hamelin
// 2004 Universit de Sherbrooke
//


// TODO -- Because of the typical usage pattern of circular trigonometrics, and because current implementation relies on an API
// extensively tested with previous element-wise operations, we only test scalar arguments to these circular trigonometrics.  Add
// more tests if problems are encountered upon usage.

x = ad_ivar(2);
F = sin(x);
DF = Expr_Gradient(F, 1, %f);
assertExpr(DF, cos(2));
DDF = Expr_Gradient(DF, 1, %f);
assertExpr(DDF, -sin(2));
DDDF = Expr_Gradient(DDF, 1, %f);
assertExpr(DDDF, -cos(2));
DDDDF = Expr_Gradient(DDDF, 1, %f);
assertExpr(DDDDF, Expr_GetEvaluation(F));
F = cos(x);
DF = Expr_Gradient(F, 1, %f);
assertExpr(DF, -sin(2));
F = atan(x);
DF = Expr_Gradient(F, 1, %f);
assertExpr(DF, 1/5);
DDF = Expr_Gradient(DF, 1, %f);
assertExpr(DDF, -4/25);


printf("Deriv. expr. - Circular trigonometrics : all unit tests passed.\n");


// End of script.

