//
// Tests on numerical evaluation of derivatives : absolute value.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


assertNumGradient(abs(ad_ivar(3)), 1, 1, %eps);
assertNumGradient(abs(ad_ivar(-1.4)), 1, -1, %eps);
assertNumGradient(abs(ad_ivar(0)), 1, 0, %eps);

x = ad_ivar([7;0;1;-2;3]);
assertNumGradient(abs(x(2) + x(4)), 5, [0,-1,0,-1,0], %eps);
assertNumGradient(abs(x(2)) + abs(x(4)), 5, [0,0,0,-1,0], %eps);
assertNumGradient(abs(x(1) * x(4)), 5, [2,0,0,-7,0], %eps);
assertNumJacobian(abs(x .^ 2 - 7 * x + 3), 5, eye(5,5), ...
	[...
		7, 0, 0, 0 , 0 ; ...
		0,-7, 0, 0 , 0 ; ...
		0, 0, 5, 0 , 0 ; ...
		0, 0, 0,-11, 0 ; ...
		0, 0, 0, 0 , 1   ...
	], %eps);


clear x;

printf("Deriv. num. - Absolute value : all unit tests passed.\n");


// End of script.

