//
// Tests on numerical evaluation of derivatives : base.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


x = ad_ivar(4);
assertNumGradient(x, 1, 1, %eps);
assertNumGradient(-x, 1, -1, %eps);
assertNumGradient(x + x + x, 1, 3, %eps);
assertNumGradient(x - x + x - x + (-x), 1, -1, %eps);

y = ad_ivar([4;7;-1;8;0]);
assertNumGradient(y(1) + y(2) + y(3) - y(4) + y(5) + y(3), 5, [1, 1, 2, -1, 1], %eps);
assertNumGradient(y(3), 5, [0,0,1,0,0], %eps);

assertNumJacobian(y, 5, eye(5,5), eye(5,5), %eps);
assertNumJacobian(y, 5, [1,0,0,0,0], [1,0,0,0,0], %eps);
assertNumJacobian(y, 5, [1,0,1,0,0], [1,0,1,0,0], %eps);
assertNumJacobian(y - y(5:-1:1), 5, eye(5,5), ...
	[...
		 1,  0,  0,  0, -1; ...
		 0,  1,  0, -1,  0; ...
		 0,  0,  0,  0,  0; ...
		 0, -1,  0,  1,  0; ...
		-1,  0,  0,  0,  1  ...
	], %eps);
assertNumJacobian(y - y(5:-1:1), 5, [0,1,0,0,0 ; 1,0,0,0,0], [0,1,0,-1,0 ; 1,0,0,0,-1], %eps);
assertNumJacobian(y([2,4]) + y([3,5]) - y([1,3]), 5, eye(2,2), ...
	[...
		-1,  1,  1,  0,  0; ...
		 0,  0, -1,  1,  1  ...
	], %eps);
assertNumJacobian(y([2,4]) + y([3,5]) - y([1,3]), 5, [1,1], [-1, 1, 0, 1, 1], %eps);

assertNumJacobian(y', 5, [0;0;1;0;0], [0,0,1,0,0], %eps);
assertNumJacobian(y' - y(5:-1:1)', 5, [0,1 ; 1,0 ; 0,0 ; 0,0 ; 1,0], [-1,1,0,-1,1 ; 1,0,0,0,-1], %eps);


clear x;
clear y;

printf("Deriv. num. - Base : all unit tests passed.\n");


// End of script.

