//
// Tests on numerical evaluation of derivatives : circular trigonometrics primitives.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


y = ad_ivar(%pi / 6);
assertNumGradient(sin(y) + cos(y) + atan(y), 1, sqrt(3) / 2 - 1/2 + 1 / (1 + %pi^2 / 36), 1e-8);
x = ad_ivar([0,sqrt(3)/3,-%pi/6,1,%pi/3]);
assertNumGradient(sin(x(3) + x(5)) * atan(x(2) * x(4)) * cos(x(1) + x(3)), 5, [%pi/24,3*sqrt(3)/16,%pi/6,3/16,%pi/8], %eps);
x = ad_ivar([5 * %pi / 6,sqrt(3)/3,-%pi/6,1,%pi/3]);
assertNumJacobian(sin(x([1,5,3])) .* atan(x([2,4,2])) .* cos(x([5,5,1])), 5, eye(3,3), ...
	[...
		-%pi * sqrt(3) / 24, 3 / 16          , 0       , 0          , -%pi * sqrt(3) / 24 ; ...
		0                  , 0               , 0       , sqrt(3) / 8, -%pi / 8            ; ...
		%pi / 24           , 3 * sqrt(3) / 16, -%pi / 8, 0          , 0                     ...
	], 1e-8);


clear x;
clear y;

printf("Deriv. num. - Circ. trigonometrics : all unit tests passed.\n");


// End of script.

