//
// Tests : absolute value of expression hypermatrices.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


x = ad_ivar(5);
assertExpr(abs(x), 5);
assertExpr(abs(-x), 5);

z = ad_ivar([10;-1e-9;0;-3;5]);
y = z(1:4);
x = z(5);
M = abs([y, [-x;-(-x);3;-1], [1e-15;8;-1;0]]);
assertExpr(M, [10,5,1e-15 ; 1e-9,5,8 ; 0,3,1 ; 3,1,0]);
//assertExpr(M(6), 5);  // Single-index extraction not supported anymore on matrices.
//assertExpr(M([4:9]), [3;5;5;3;1;1e-15]);  // Single-index extraction not supported anymore on matrices.
//assertExpr(M([7,$,2]), [3;0;1e-9]);
//assertExpr(M(:), [10;1e-9;0;3;5;5;3;1;1e-15;8;1;0]);
assertExpr(M(3,3), 1);
assertExpr(M(:,3), [1e-15;8;1;0]);
assertExpr(M(2,:), [1e-9,5,8]);
assertExpr(M($,$), 0);

clear x;
clear y;
clear z;
clear M;

printf("Expr - Absolute value : all unit tests passed.\n");


// End of module.

