//
// Tests : addition of scalars to more complex expression hypermatrices.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


z = ad_ivar([5;1;6;-2;0;3]);
x = z(1);
y = z(2:$);
//x = ad_ivar("x", 5);
//y = ad_ivar("y", [1;6;-2;0;3]);
s = x + y;
assert(and(size(s) == size(y)));
assert(and(Expr_GetEvaluation(s) == [6;11;3;5;8]));
s = y + 2;
assert(and(size(s) == size(y)));
assert(and(Expr_GetEvaluation(s) == [3;8;0;2;5]));

y = y';
s = y + x;
assert(and(size(s) == size(y)));
assert(and(Expr_GetEvaluation(s) == [6,11,3,5,8]));
s = 2 + y;
assert(and(size(s) == size(y)));
assert(and(Expr_GetEvaluation(s) == [3,8,0,2,5]));

M = [y ; 4,x,5,x,-5 ; y($:-1:1)];
s = x + M;
assert(and(size(s) == size(M)));
assert(and(Expr_GetEvaluation(s) == [6,11,3,5,8 ; 9,10,10,10,0 ; 8,5,3,11,6]));
s = M + 9;
assert(and(size(s) == size(M)));
assert(and(Expr_GetEvaluation(s) == [10,15,7,9,12 ; 13,14,14,14,4 ; 12,9,7,15,10]));

// NOTE : hypermatrices not supported anymore as parts of a SCIAD expression.
//H = ad_const(hypermat([3,3,3], 1:27));
//s = H + x;
//assert(and(size(s) == size(H)));
//ev = Expr_GetEvaluation(H);
//assert(and(ev(:)' == ((1:27) + 5)));
//s = 2 + H;
//assert(and(size(s) == size(H)));
//ev = Expr_GetEvaluation(H);
//assert(and(ev(:)' == ((1:27) + 2)));


clear z;
clear x;
clear y;
clear s;
clear M;
clear H;
clear ev;

printf("Expr - Addition to scalar : all unit tests passed.\n");


// End of script.

