//
// Tests : replacement of leaves with other expressions.
//
// Author : Benoit Hamelin
// 2004 Universit de Sherbrooke
//


x = ad_ivar([7;-1;1;-2;3]);
F = x(2);
sub = x(3) - x(4);
assertExprEdges(Expr_ReplaceLeaf(F, 1, sub), ...
	[ ...
		2, 1, 3 ; ...
		3, 4, 4   ...
	]);

F = x(1) - x(5);
assertExprEdges(Expr_ReplaceLeaf(F, 1, sub), ...
	[ ...
		5, 2, 1, 3, 4, 6 ; ...
		6, 3, 4, 4, 7, 7   ...
	]);
assertExprEdges(Expr_ReplaceLeaf(F, 2, sub), ...
	[ ...
		3, 2, 4, 5, 1, 6 ; ...
		4, 5, 5, 6, 7, 7   ...
	]);

F = (x(1) + x(2)) + (-x(3) + (x(4) + x(5)));
assertExprEdges(Expr_ReplaceLeaf(F, 2, sub), ...
	[ ...
		1, 3, 2, 4, 5, 7,  9, 10,  8, 11,  6, 12 ; ...
		6, 4, 5, 5, 6, 8, 11, 11, 12, 12, 13, 13   ...
	]);
assertExprEdges(Expr_ReplaceLeaf(F, 4, sub), ...
	[ ...
		1, 2, 5, 4, 6, 7,  9, 10,  8, 11,  3, 12 ; ...
		3, 3, 6, 7, 7, 8, 11, 11, 12, 12, 13, 13   ...
	]);
assertExprEdges(Expr_ReplaceLeaf(F, 6, sub), ...
	[ ...
		1, 2, 4, 7, 6, 8,  9, 10,  5, 11,  3, 12 ; ...
		3, 3, 5, 8, 9, 9, 11, 11, 12, 12, 13, 13   ...
	]);
sub2 = x(5);
edg = Expr_GetEdges(F);
assertExprEdges(Expr_ReplaceLeaf(F, 1, sub2), edg);
assertExprEdges(Expr_ReplaceLeaf(F, 2, sub2), edg);
assertExprEdges(Expr_ReplaceLeaf(F, 4, sub2), edg);
assertExprEdges(Expr_ReplaceLeaf(F, 6, sub2), edg);
assertExprEdges(Expr_ReplaceLeaf(F, 7, sub2), edg);


clear x;
clear F;
clear sub;
clear sub2;
clear edg;

printf("Expr - Replacement of leaves with sub-expressions : all unit tests passed.\n");


// End of script.
