//
// Tests : extraction of sub-expressions.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


x = ad_ivar([7;-1;1;-2;3]);
F = x;
assertExpr(Expr_ExtractSubExpr(F, 1), [7;-1;1;-2;3]);
F = x + x(5:-1:1);
assertExpr(Expr_ExtractSubExpr(F, 3), [10;-3;2;-3;10]);
assertExpr(Expr_ExtractSubExpr(F, 1), [7;-1;1;-2;3]);
assertExpr(Expr_ExtractSubExpr(F, 2), [3;-2;1;-1;7]);
F = -x;
assertExpr(Expr_ExtractSubExpr(F, 2), [-7;1;-1;2;-3]);
assertExpr(Expr_ExtractSubExpr(F, 1), [7;-1;1;-2;3]);

F = x(1) + x(2) + x(5) + x(4);
assertExpr(Expr_ExtractSubExpr(F, 6), -2);
assertExpr(Expr_ExtractSubExpr(F, 3), 6);
assertExpr(Expr_ExtractSubExpr(F, 5), 9);

F = x(1) - x(2) + (x(3) - x(4) + x(5)) + x(3);
assertExpr(F, 15);
assertExpr(Expr_ExtractSubExpr(F, 12), 1);
assertExpr(Expr_ExtractSubExpr(F, 10), 6);
assertExpr(Expr_ExtractSubExpr(F, 3), 1);
assertExpr(Expr_ExtractSubExpr(F, 4), 8);
assertExpr(Expr_ExtractSubExpr(F, 11), 14);


clear x;
clear F;

printf("Expr - Extraction of sub-expressions : all unit tests passed.\n");


// End of script.

