//
// Tests : sum primitive applied on two-dimensional hypermatrices.
//
// Author : Benoit Hamelin
// 2002 Universit de Sherbrooke
//


z = ad_ivar([1;1;5;-2;0;3]);
x = z(1);
y = z(2:$);

assertExpr(sum(x), 1);
assertExpr(sum(x'), 1);
assertExpr(sum(y), 7);
assertExpr(sum(y'), 7);
assertExpr(sum(y, "c"), Expr_GetEvaluation(y));
assertExpr(sum(y, "r"), 7);
assertExpr(sum(y', "c"), 7);
assertExpr(sum(y', "r"), [1,5,-2,0,3]);

p = sum(y);
assertExpr(p(1), 7);
assertExpr(p($), 7);
assertExpr(p(:), 7);
assertExpr(p(1,1), 7);
assertExpr(p(:,$), 7);

M = [y' ; x,-6,y(5),1,0 ; y(2),x,x,0,-9];
assertExpr(sum(M), 4);
assertExpr(sum(M, "r"), [7,0,2,1,-6]);
assertExpr(sum(M, 1), [7,0,2,1,-6]);
assertExpr(sum(M, "c"), [7;-1;-2]);
assertExpr(sum(M, 2), [7;-1;-2]);

p = sum(M);
assertExpr(p(1), 4);
assertExpr(p($), 4);
assertExpr(p(:), 4);
assertExpr(p(1,1), 4);
assertExpr(p(:,$), 4);

p = sum(M, "r");
assertExpr(p(2), 0);
assertExpr(p(1:4), [7,0,2,1]);
assertExpr(p([3,$]), [2,-6]);
assertExpr(p(:), [7;0;2;1;-6]);
assertExpr(p(1,4), 1);
assertExpr(p(1,[2,$,1]), [0,-6,7]);
assertExpr(p(1,:), [7,0,2,1,-6]);

p = sum(M, "c");
assertExpr(p(2), -1);
assertExpr(p(2:3), [-1;-2]);
assertExpr(p($), -2);
assertExpr(p(:), [7;-1;-2]);
assertExpr(p(3,1), -2);
assertExpr(p([2,$,1],1), [-1;-2;7]);
assertExpr(p(:,1), [7;-1;-2]);


clear x;
clear y;
clear p;
clear M;

printf("Expr - Sum : all unit tests passed.\n");

// End of script.

