//
// Tests on Taylor development : base and addition.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


x = ad_ivar(4);

// Elementary tests...
assertTaylor(x, 4, 3, [3;1;0;0;0], 1e-15);
assertTaylor(ad_const(56), 4, 3, [56;0;0;0;0], 1e-15);

// Tests with addition.
assertTaylor(x + 6, 4, 3, [9;1;0;0;0], 1e-15);
assertTaylor(x + x + x + x, 4, 3, [12;4;0;0;0], 1e-15);

// Tests with additive inversion.
assertTaylor(-x, 4, 3, [-3;-1;0;0;0], 1e-15);
assertTaylor(8 - x, 4, 3, [5;-1;0;0;0], 1e-15);


clear x;

printf("Taylor dev. - Base : all unit tests passed.\n");


// End of script.

