//
// Tests on Taylor development : element-wise product.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


x = ad_ivar(4);

// Tests on scalars.
assertTaylor((2 * x) .* (3 * x * x), 4, 3, [162 ; 162 ; 54 ; 6 ; 0], 1e-15);

// Tests on vector and matrix products.
assertTaylor([5;x;x*x;-x] .* [x*x*x;-1;-2*x;x*x*x], 4, 3, ...
	[135,135,45,5,0 ; -3,-1,0,0,0 ; -54,-54,-18,-2,0 ; -81,-108,-54,-12,-1], 1e-15);
assertTaylor([5,x,x*x,-x] .* [x*x*x,-1,-2*x,x*x*x], 4, 3, ...
	[135,135,45,5,0 ; -3,-1,0,0,0 ; -54,-54,-18,-2,0 ; -81,-108,-54,-12,-1]', 1e-15);
assertTaylor([5,x ; x*x,-x] .* [x*x*x,-1 ; -2*x,x*x*x], 4, 3, ...
	hypermat([2,2,5], [135;-54;-3;-81 ; 135;-54;-1;-108 ; 45;-18;0;-54 ; 5;-2;0;-12 ; 0;0;0;-1]), 1e-15);

// Tests on scalar times more complex objects.
assertTaylor([5*x,x*x,-1] * (3*x), 4, 3, [135,81,-9 ; 90,81,-3 ; 15,27,0; 0,3,0 ; 0,0,0], 1e-15);
assertTaylor((3*x) * [5*x;x*x;-1], 4, 3, [135,81,-9 ; 90,81,-3 ; 15,27,0; 0,3,0 ; 0,0,0]', 1e-15);
assertTaylor(x * [2,3*x*x ; 0,5*x ; -x,-3], 4, 3, ...
	hypermat([3,2,5], [6;0;-9;81;45;-9 ; 2;0;-6;81;30;-3 ; 0;0;-1;27;5;0 ; 0;0;0;3;0;0 ; 0;0;0;0;0;0]), 1e-15);
assertTaylor([2,3*x*x ; 0,5*x ; -x,-3] * x, 4, 3, ...
	hypermat([3,2,5], [6;0;-9;81;45;-9 ; 2;0;-6;81;30;-3 ; 0;0;-1;27;5;0 ; 0;0;0;3;0;0 ; 0;0;0;0;0;0]), 1e-15);


clear x;

printf("Taylor dev. - Element-wise product : all unit tests passed.\n");


// End of script.

