//
// Tests on Taylor development : regular and element-wise inversion.
//
// Author : Benoit Hamelin
// 2003 Universit de Sherbrooke
//


x = ad_ivar(4);

// Regular division.
assertTaylor(inv(x), 4, 3, [1/3 ; -1/9 ; 1/27 ; -1/81 ; 1/243], 1e-15);
assertTaylor((x*x + x) / (2 - x*x*x), 3, 3, [-12/25 ; 149/625 ; -1948/15625 ; 26571 / 390625], 1e-15);

// Element-wise division.
assertTaylor((x*x + x) ./ (2 - x*x*x), 3, 3, [-12/25 ; 149/625 ; -1948/15625 ; 26571 / 390625], 1e-15);
assertTaylor([x*x+1;3;x-2;x*x*x] ./ [x*x*x;x*x-1;x+4;x*x-x], 3, 3, ...
	[ ...
		10/27,	- 4/27,	  5/ 81,	-19/ 729 ; ...
		 3/ 8,	-18/64,	 21/128,	-45/ 512 ; ...
		 1/ 7,	  6/49,	- 6/343,	  6/2401 ; ...
		 9/ 2,	  3/ 4,	  1/  8,	- 1/  16   ...
	], 1e-15);
assertTaylor([x*x+1,3,x-2,x*x*x] ./ [x*x*x,x*x-1,x+4,x*x-x], 3, 3, ...
	[ ...
		10/27,	- 4/27,	  5/ 81,	-19/ 729 ; ...
		 3/ 8,	-18/64,	 21/128,	-45/ 512 ; ...
		 1/ 7,	  6/49,	- 6/343,	  6/2401 ; ...
		 9/ 2,	  3/ 4,	  1/  8,	- 1/  16   ...
	]', 1e-15);
assertTaylor([x*x+1,x-2;3,x*x*x] ./ [x*x*x,x+4;x*x-1,x*x-x], 3, 3, ...
	hypermat([2,2,4], ...
		[ ...
			 10/ 27;	  3/  8;	 1/   7;	 9/ 2;	...
			- 4/ 27;	-18/ 64;	 6/  49;	 3/ 4;	...
			  5/ 81;	 21/128;	-6/ 343;	 1/ 8;	...
			-19/729;	-45/512;	 6/2401;	-1/16	...
		]), 1e-15);


clear x;

printf("Taylor dev. - Division : all unit tests passed.\n");


// End of script.
