//
// Tests for Sciad utility tools.
//
// Author : Benoit Hamelin
// 2002 Universit de Sherbrooke
//


t1 = ad_ivar((1:5)');
t2 = ad_const(1:10);
t3 = ad_const(matrix(1:12, [3,4]));
t4 = ad_const(hypermat([3,3,4], 1:36));

assert(and(zeros(t1) == zeros(5, 1)));
assert(and(zeros(t2) == zeros(1, 10)));
assert(and(zeros(t3) == zeros(3, 4)));
h = zeros(t4);
assert(and(size(h) == [3,3,4]));
assert(and(h(:) == zeros(36, 1)));

assert(and(ones(t1) == ones(5, 1)));
assert(and(ones(t2) == ones(1, 10)));
assert(and(ones(t3) == ones(3, 4)));
h = ones(t4);
assert(and(size(h) == [3,3,4]));
assert(and(h(:) == ones(36, 1)));

r = rand(t1);
assert(and(size(r) == [5,1]));
assert(and([(r >= 0), (r < 1)]));
r = rand(t2);
assert(and(size(r) == [1,10]));
assert(and([(r >= 0), (r < 1)]));
r = rand(t3);
assert(and(size(r) == [3,4]));
assert(and([(r >= 0), (r < 1)]));
r = rand(t4);
assert(and(size(r) == [3,3,4]));
assert(and([(r(:) >= 0), (r(:) < 1)]));

assert(and(eye(t1) == eye(5, 1)));
assert(and(eye(t2) == eye(1, 10)));
assert(and(eye(t3) == eye(3, 4)));
assertError("eye(t4)");

clear h;
clear r;
clear t1;
clear t2;
clear t3;
clear t4;


printf("Utils : all unit tests passed.\n");


// End of script.

