function [fvec,J]=bard(n,m,x,opt)
fvec=[];J=[];
// **************************************************************
// **************************************************************
//  function [fvec,J]= bard(n,m,x,opt)
//  Bard function       [8] 
//  Dimensions  n=3,    m=15
//  Function definition:
//       f(x) = y(i) - [x1 + (u(i) / v(i)x2 + w(i)x3)]
//       where u(i) = i, v(i) = 16-i, w(i) = min(u(i),v(i))
//  Standard starting point at x= (1,1,1)
//  Minima f=8.21487...10^(-3)   and f=17.4286 at (0.8406...,-inf,-inf)
// 
//  Revised 10/23/94   PLK
// **************************************************************
 
 
y = [0.14,0.18,0.22,0.25,0.29,0.32,0.35,0.39,0.37,0.58;0.73,0.96,1.34,2.1,4.39,0,0,0,0,0]';
 
J = zeros(m,n);
 
for i = 1:m
   
  u(1,i) = i;
  v(1,i) = 16-i;
  w(1,i) = min(u(i),v(i));
   
  if opt==1|opt==3 then
    fvec(1,i) = y(i)-(x(1)+u(i)/(v(i)*x(2)+w(i)*x(3)));
  end
   
  if opt==2|opt==3 then
    J(i,1) = -1;
    J(i,2) = u(i)*v(i)/((v(i)*x(2)+w(i)*x(3))^2);
    J(i,3) = u(i)*w(i)/((v(i)*x(2)+w(i)*x(3))^2);
  end
   
   
end
fvec = fvec';
if opt<1|opt>3 then
  disp('Error: Option value sent to BARD.M is either <1 or >3');
end
 
 
 
 
