function [fvec,J]=meyer(n,m,x,opt)
fvec=[];J=[];
 
// ************************************************
// ************************************************             
// function [fvec,J]= meyer(n,m,x,opt)
// Meyer function   [10]
// Dimensions   n=3   m=16
// Function definition:
//       f(x) = x(1)*exp[x(2)/(t(i) + x(3))]-y(i)
//       where t(i)= 45 + 5i
// Standard starting point at x=(0.02,4000,250)
// Minima of f=87.9458...
// 
// Revised 10/23/94      PLK
// ************************************************
 
 
zero = 0;
one = 1;
 
y = [34780;28610;23650;19630;16370;13720;11540;9744;8261;7030;6005;5147;4427;3820;3307;2872]';
 
x1 = x(1);
x2 = x(2);
x3 = x(3);
 
if opt==1 then
  for i = 1:m
    ti = 45+5*i;
    di = ti+x3;
    ei = exp(x2/di);
    fvec(1,i) = x1*ei-y(i);
  end
  fvec = fvec';
   
elseif opt==2 then
  for i = 1:m
    ti = 45+5*i;
    di = ti+x3;
    qi = one/di;
    ei = exp(x2*qi);
    si = x1*qi*ei;
    J(i,1) = ei;
    J(i,2) = si;
    J(i,3) = -x2*qi*si;
  end
   
elseif opt==3 then
  for i = 1:m
    ti = 45+5*i;
    di = ti+x3;
    qi = one/di;
    ei = exp(x2*qi);
    si = x1*qi*ei;
    fvec(1,i) = x1*ei-y(i);
    J(i,1) = ei;
    J(i,2) = si;
    J(i,3) = -x2*qi*si;
  end
  fvec = fvec';
   
else
  disp('Error: Option value sent to MEYER.M is either <1 or >3');
end
 
 
