function [x,histout,costdata] = test(%nprob,algo)
    [%n,%m,x0] = initf(%nprob)
    getf("/home/dussault/import/scimatlab/uncprobs/scilab/" + name(%nprob) + ".sci");

    deff('[fout,gout]=f(x)','fout=objfcn(%n,%m,x,%nprob); gout=grdfcn(%n,%m,x,%nprob)')
    tol = 1e-15 //0.000001
 
    [x,histout,costdata,xgra,ygra]=algo(x0,f,tol,500)
    xmin=min(xgra)
    xmax=max(xgra)
    ymin=min(ygra)
    ymax=max(ygra)
    xcentre=(xmin+xmax)/2
    xlarg = xmax-xmin
    ycentre=(ymin+ymax)/2
    ylarg = ymax-ymin
    xbasc(0)
    xgrid(3)
    if %n==2,
       //xd = [min(x(1),x0(1)),min(x(2),x0(2))];
       //dx = [abs(x(1)-x0(1)),abs(x(2)-x0(2))];
       nbgrid=30
       //x1g=-1.3;x1d=1.1;
       x1g = xcentre - xlarg * 0.55
       x1d = xcentre + xlarg * 0.55
       //x2g=-0.1;x2d=1.1;
       x2g = ycentre - ylarg * 0.55
       x2d = ycentre + ylarg * 0.55
       dx=[(x1d-x1g)/nbgrid,(x2d-x2g)/nbgrid]
       for i=1:nbgrid,
           xg(i)=x1g +(i-1)*dx(1)
           yg(i)=x2g +(i-1)*dx(2)
       end
       for i=1:nbgrid,
           for j=1:nbgrid,
               zg(i,j) = f([xg(i),yg(j)])
           end
       end
       //contour2d(xg,yg,zg,[0.5,1:10])
       contour2d(xg,yg,zg,10)
    end

    plot2d(xgra,ygra,-15)
    plot2d(xgra,ygra,7)


function [x,histout,costdata] = testcomp(%nprob)
    [%n,%m,x0] = initf(%nprob)
	BASE_DIR = "/home/hamelin/Documents/recherche/autodiff/experiments/finite_diff_optim/uncprobs/scilab/"
    getf(BASE_DIR + name(%nprob) + ".sci");

    deff('[fout,gout]=f(x)','fout=objfcn(%n,%m,x,%nprob); gout=grdfcn(%n,%m,x,%nprob)')
    //tol = 0.000001
	tol = 1e-14
 //
    [x,histout,costdata,xgra,ygra]=ntrust(x0,f,tol,130)
disp(x)
    xmin=min(xgra)
    xmax=max(xgra)
    ymin=min(ygra)
    ymax=max(ygra)
    xbasc(0)
    xgrid(3)
    plot2d(xgra,ygra,-15)
    plot2d(xgra,ygra,7)
	pause
//
    //[x,histout,costdata,xgra,ygra]=cgtrust(x0,f,tol,100)
//disp(x)
    //xmin=min(xmin,min(xgra))
    //xmax=max(xmax,max(xgra))
    //ymin=min(ymin,min(ygra))
    //ymax=max(ymax,max(ygra))
    //plot2d(xgra,ygra,-4)
    //plot2d(xgra,ygra,2)
//pause
    [x,histout,costdata,xgra,ygra]=bfgswopt(x0,f,1e-15,200)
disp(x)
	pause
    xmin=min(xmin,min(xgra))
    xmax=max(xmax,max(xgra))
    ymin=min(ymin,min(ygra))
    ymax=max(ymax,max(ygra))
    plot2d(xgra,ygra,-3)
    plot2d(xgra,ygra,1)
  
    xcentre=(xmin+xmax)/2
    xlarg = xmax-xmin
    ycentre=(ymin+ymax)/2
    ylarg = ymax-ymin
   //if %n==2,
       //xd = [min(x(1),x0(1)),min(x(2),x0(2))];
       //dx = [abs(x(1)-x0(1)),abs(x(2)-x0(2))];
       nbgrid=30
       //x1g=-1.3;x1d=1.1;
       x1g = xcentre - xlarg * 0.55
       x1d = xcentre + xlarg * 0.55
       //x2g=-0.1;x2d=1.1;
       x2g = ycentre - ylarg * 0.55
       x2d = ycentre + ylarg * 0.55
       dx=[(x1d-x1g)/nbgrid,(x2d-x2g)/nbgrid]
       for i=1:nbgrid,
           xg(i)=x1g +(i-1)*dx(1)
           yg(i)=x2g +(i-1)*dx(2)
       end
       for i=1:nbgrid,
           for j=1:nbgrid,
               zg(i,j) = f([xg(i),yg(j),x(3:%n)'])
           end
       end
       contour2d(xg,yg,zg,[0.5,1:10])
       //contour2d(xg,yg,zg,30)
    //end


function [total] = testtous(algo)
    liste = [1:19,23,25,26,28:34]
    total = zeros(1,3)
    for i=liste
        [x,histout,costdata] = test(i,algo)
        disp([i,costdata])
        total = total + costdata
    end

